reset;

#constantes:
pi=3.141592654
obli=23.5*pi/180. #obliquité

#param:
phi=$0*pi/180. #latitude du lieu
j=$1 #jour
m=$2 #mois
j=(m < 1.1 ? j : j+31) #janv
j=(m < 2.1 ? j : j+28) #fev
j=(m < 3.1 ? j : j+31) #mars
j=(m < 4.1 ? j : j+30) #avr
j=(m < 5.1 ? j : j+31) #mai
j=(m < 6.1 ? j : j+30) #juin
j=(m < 7.1 ? j : j+31) #juil
j=(m < 8.1 ? j : j+31) #aout
j=(m < 9.1 ? j : j+30) #sep
j=(m < 10.1 ? j : j+31) #oct
j=(m < 11.1 ? j : j+30) #nov
l=(j-81.)*360./365.25*pi/180. # long. ecli. du soleil

ads=(cos(l)> 0 ? atan(tan(l)*cos(obli)) : pi+atan(tan(l)*cos(obli)))
ads=(ads < -pi ? ads+2*pi : (ads > pi ? ads-2*pi : ads)) # ascention droite du soleil

ts=$3 # tps sidérale (entre 0 et 24h)
ts=(ts > 24. ?  ts=ts-24 : (ts < 0 ? (ts+24.) : ts))
ts=ts*pi/12.

hsv=ts-ads+pi #heure solaire vraie (locale)
hsv=(hsv > 2.*pi ? hsv=hsv-2.*pi : hsv)

#dimension des axes
xmin=-3
xmax=3

ymin=-3
ymax=-ymin

#fonctions


xp(alpha,delta)=tan(pi*.25-delta*.5)*cos(alpha) #projection stereographique
yp(alpha,delta)=tan(pi*.25-delta*.5)*sin(alpha)

dist(x1,y1,x2,y2)=sqrt((x1-x2)**2+(y1-y2)**2) 

#les fonctions suivantes ne servent qu'à définir le rayon et le centre de la projection d'un cercle de la sphère céleste de centre E(alpha,delta) et de rayon z
a1(alpha,delta,z)=(delta+z < pi*.5 ? alpha : pi+alpha)
b1(alpha,delta,z)=(delta+z < pi*.5 ? delta+z:pi-(delta+z))
xp1(alpha,delta,z)=xp(a1(alpha,delta,z),b1(alpha,delta,z))
yp1(alpha,delta,z)=yp(a1(alpha,delta,z),b1(alpha,delta,z))

a2(alpha,delta,z)=(delta-z > -pi*.5 ? alpha : pi+alpha)
b2(alpha,delta,z)=(delta-z > -pi*.5 ? delta-z:-pi-(delta-z))
xp2(alpha,delta,z)=xp(a2(alpha,delta,z),b2(alpha,delta,z))
yp2(alpha,delta,z)=yp(a2(alpha,delta,z),b2(alpha,delta,z))

rayon(alpha,delta,z)=dist(xp1(alpha,delta,z),yp1(alpha,delta,z),xp2(alpha,delta,z),yp2(alpha,delta,z))*.5 #le rayon

xcp(alpha,delta,z)=(xp1(alpha,delta,z)+xp2(alpha,delta,z))*.5 #coordonnées du centre
ycp(alpha,delta,z)=(yp1(alpha,delta,z)+yp2(alpha,delta,z))*.5

#fonctions utiles pour tracer des méridien à partir de la définition du pole du méridien (qui correspond alors à un cercle sur la sphère céleste de rayon 90°
deltap(phi,A)=asin(-cos(phi)*cos(A))
alphap(phi,A,delta)=(sin(phi)*cos(A) > 0. ? asin(sin(A)/cos(delta)) : pi- asin(sin(A)/cos(delta)))


#détermine si le soleil est couché ou levé
delta_sol(lsol)=asin(cos(pi*.5-obli)*cos(lsol-pi*.5))
sinush(phi,lsol,hsv)=sin(phi)*sin(delta_sol(lsol))+cos(phi)*cos(delta_sol(lsol))*cos(hsv-pi)
leve(phi,lsol,hsv)=(sinush(phi,lsol,hsv) > 0 ? 1 : 0) # 1 si levé, 0 si couché


#styles de ligne
set style line 1 lt 1 lw 3 lc rgb "red" #delta = 0 (equateur)
set style line 2 lt 1 lw 1 lc rgb "red" #delta 
set style line 3 lt 1 lw 1 lc rgb "red" #alpha=cte
set style line 4 lt 1 lw 2 lc rgb "black" pt 3 ps 1 #zenith
set style line 5 lt 1 lw 3 lc rgb "dark-green" #h=0
set style line 6 lt 1 lw 1 lc rgb "black" #h/=0
set style line 7 lt 1 lw 1 lc rgb "black" #A=cte
set style line 8 lt 1 lw 3 lc rgb "yellow" #eclitpique
set style line 9 lt 1 lw 2 lc rgb "yellow" pt 6 ps 1 #soleil
set style line 13 lt 1 lw 2 lc rgb "brown" pt 6 ps 1 #soleil
set style line 10 lt 1 lw 2 lc rgb "red" pt 6 ps 1 #pint vernal
set style line 11 lt 1 lw 2 lc rgb "red" pt 7 ps 0.5 #étoile
set style line 12 lt 1 lw 2 lc rgb "blue" pt 7 ps 0.5 #mois

#label
set label "ts= %.2f h",(ts*12./pi) at xmin+.2,ymax-.2 tc rgb "white"
set label "hsv= %.2f h",(hsv*12./pi) at xmax-1.,ymax-.2 tc rgb "white"
set label "date= %.0f",($1),"/%.0f",($2),"        lat=%.1f",phi*180./pi at  (xmin+xmax)*.5,ymax-.2 center tc rgb "white"

#set grid

set key off

set size square

set zeroaxis lt 1 lw 1 lc rgb "black"

set xrange[xmin:xmax]

set yrange[ymin:ymax]

set multiplot

plot 3 w filledc x1 lc rgb "light-green" #fond du graph

#projection du tympan local (independant du temps mais dépendant de la latitude)


#crépuscule:
alpha=0.0
delta=phi
set param
#z=96.*pi/180.
#x0=xcp(alpha,delta,z)
#y0=ycp(alpha,delta,z)
#r=rayon(alpha,delta,z)
#plot x0+r*cos(t),y0+r*sin(t) w filledc lc rgb "grey60"# ls 6
#horizon
set param
z=90.*pi/180.
x0=xcp(alpha,delta,z)
y0=ycp(alpha,delta,z)
r=rayon(alpha,delta,z)
plot x0+r*cos(t),y0+r*sin(t) w filledc lc rgb (leve(phi,l,hsv) ==1 ? "light-blue" : "dark-blue")  #l ls 5
plot x0+r*cos(t),y0+r*sin(t) w l ls 5
#zenith
alpha=0.0
delta=phi
set param
plot xp(alpha,delta),yp(alpha,delta) w p ls 4
#azimuth
z=90.*pi/180.
A=0. #E-O
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
x0=xcp(alpha,delta,z)
y0=ycp(alpha,delta,z)
r=rayon(alpha,delta,z)
plot x0+r*cos(t),y0+r*sin(t) w l ls 6
A=-45.*pi/180. #SO-NE
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
x0=xcp(alpha,delta,z)
y0=ycp(alpha,delta,z)
r=rayon(alpha,delta,z)
plot x0+r*cos(t),y0+r*sin(t) w l ls 6
A=45.*pi/180. #SE-NO
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
x0=xcp(alpha,delta,z)
y0=ycp(alpha,delta,z)
r=rayon(alpha,delta,z)
plot x0+r*cos(t),y0+r*sin(t) w l ls 6
A=90.*pi/180. #S-N
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
x0=xcp(alpha,delta,z)
y0=ycp(alpha,delta,z)
r=rayon(alpha,delta,z)
plot x0+r*cos(t),y0+r*sin(t) w l ls 6

#point cardinaux
A=0.
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'S' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center 
A=pi*.25
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'SO' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center 
A=pi*.5
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'O' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center  
A=pi*.75
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'NO' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center  
A=pi
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'N' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center   
A=pi*1.25
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'NE' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center  
A=-pi*.5
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'E' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center  
A=-pi*.25
delta=deltap(phi,A)
alpha=alphap(phi,A,delta)
set label 'SE' at xp(alpha,delta)*1.08,yp(alpha,delta)*1.08 center 



# projection de l'araignée : (indépendant de la latitude du lieu, mais dépend du tps sauf pour cercles de déclinaison)

# projection des cercles de declinaison (indpt du tps)
set param
#equateur
delta=0.0
r=abs(tan(pi*.25-delta*.5))
plot r*cos(t),r*sin(t) w l ls 1
#cercle antartique
delta=-pi*.5+obli
r=abs(tan(pi*.25-delta*.5))
plot r*cos(t),r*sin(t) w l ls 2
#tropique capricorne
delta=-obli
r=abs(tan(pi*.25-delta*.5))
plot r*cos(t),r*sin(t) w l ls 2
#tropique cancer
delta=obli
r=abs(tan(pi*.25-delta*.5))
plot r*cos(t),r*sin(t) w l ls 2
#cercle artique
delta=pi*.5-obli
r=abs(tan(pi*.25-delta*.5))
plot r*cos(t),r*sin(t) w l ls 2


# projection méridiens équatoriaux (ce sont des lignes) (ne pas tracer, ça surcharge la figure inutilement)
#alpha=ts
#alpha=(alpha > 2.*pi ?  alpha-2.*pi : (alpha < 0. ? alpha+2*pi : alpha))
#r=((abs(alpha) < pi/4. || abs(pi-alpha)<pi/4. || abs(alpha-pi*2.) < pi/4.) ? 3./abs(cos(alpha)) : 3./abs(sin(alpha)))
#set arrow from r*cos(alpha),r*sin(alpha) to -r*cos(alpha),-r*sin(alpha) nohead back ls 3

#alpha=ts+pi*.25
#alpha=(alpha > 2.*pi ?  alpha-2.*pi : (alpha < 0. ? alpha+2*pi : alpha))
#r=((abs(alpha) < pi/4. || abs(pi-alpha)<pi/4. || abs(alpha-pi*2.) < pi/4.) ? 3./abs(cos(alpha)) : 3./abs(sin(alpha)))
#set arrow from r*cos(alpha),r*sin(alpha) to -r*cos(alpha),-r*sin(alpha) nohead back ls 3

#alpha=ts+pi*.5
#alpha=(alpha > 2.*pi ?  alpha-2.*pi : (alpha < 0. ? alpha+2*pi : alpha))
#r=((abs(alpha) < pi/4. || abs(pi-alpha)<pi/4. || abs(alpha-pi*2.) < pi/4.) ? 3./abs(cos(alpha)) : 3./abs(sin(alpha)))
#set arrow from r*cos(alpha),r*sin(alpha) to -r*cos(alpha),-r*sin(alpha) nohead back ls 3

#alpha=ts+pi*.75
#alpha=(alpha > 2.*pi ?  alpha-2.*pi : (alpha < 0. ? alpha+2*pi : alpha))
#alpha=(alpha > 2.*pi ?  alpha-2.*pi : (alpha < 0. ? alpha+2*pi : alpha))
#r=((abs(alpha) < pi/4. || abs(pi-alpha)<pi/4. || abs(alpha-pi*2.) < pi/4.) ? 3./abs(cos(alpha)) : 3./abs(sin(alpha)))
#set arrow from r*cos(alpha),r*sin(alpha) to -r*cos(alpha),-r*sin(alpha) nohead back ls 3





#quelques étoiles
#sirius:
#delta=(-16.+42./60.)*pi/180.
#alpha=ts-(06+45./60.)*pi/12.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#véga
#alpha=ts-(18.+ 36./60.)*pi/12.
#delta=(+38.+47./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#bételgeuse
#alpha=ts-(05.+55./60.)*pi/12.
#delta=(+07.+24./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#aldébaran
#alpha=ts-(04.+35./60.)*pi/12.
#delta=(+16.+30./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#rigel
#alpha=ts-(5.+14./60.)*pi/12.
#delta=(-08.+12./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#deneb
#alpah=ts-(20.+41./60.)*pi/12.
#delta=(+45.+16./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#arcturus
#alpha=ts-(14.+15./60.)*pi/12.
#delta=(+19.+10./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#altaïr
#alpha=ts-(19.+50./60.)*pi/12.
#delta=(+08.+52./60.)*pi/180.
#plot xp(alpha,delta),yp(alpha,delta) w p ls 11
#à partir d'un fichier
plot 'stars4gnuplot.dat' u (xp((ts-$$1*pi/12.),$$2*pi/180.)):(yp((ts-$$1*pi/12.),$$2*pi/180.)) w p ls 11
#ligne constellation (à partir d'un fichier)
plot 'coord_const.txt' u (xp((ts-($$1)*pi/12.),($$2)*pi/180.)):(yp((ts-($$1)*pi/12.),($$2)*pi/180.)) w l ls 3



# projection cercle de l'écliptique
alpha=ts+pi*.5
delta=pi*.5-obli
z=pi*.5
x0=xcp(alpha,delta,z)
y0=ycp(alpha,delta,z)
r=rayon(alpha,delta,z)
plot x0+r*cos(t),y0+r*sin(t) w l ls 8
#le point vernal
alpha=ts
delta=0.
plot xp(alpha,delta),yp(alpha,delta) w p ls 10
# le Soleil
delta=pi*.5-obli
alpha=ts+pi*.5
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls (leve(phi,l,hsv) == 1 ? (9) :(13) )
#le premier de chaque mois
#janvier
j=1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/1
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "1" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#fevrier
j=31+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/2
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "2" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#mars
j=31+28+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/3
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "3" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#avril
j=31+28+31+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/4
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "4" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#mai
j=31+28+31+30+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/5
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "5" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#juin
j=31+28+31+30+31+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/6
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "6" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#juillet
j=31+28+31+30+31+30+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/7
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "7" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#aout
j=31+28+31+30+31+30+31+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/8
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "8" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#septembre
j=31+28+31+30+31+30+31+31+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/9
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "9" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#octobre
j=31+28+31+30+31+30+31+31+30+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/10
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "10" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#novembre
j=31+28+31+30+31+30+31+31+30+31+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/11
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "11" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12
#decembre
j=31+28+31+30+31+30+31+31+30+31+30+1
l=(j-81.)*360./365.25*pi/180. # long. ecli. du 1/12
A=l-pi*.5
deltas=asin(cos(delta)*cos(A))
alphas=asin(sin(A)/cos(deltas))
alphas=(-sin(delta)*cos(A) < 0 ? alphas=pi-alphas : alphas)
set label "12" at (1.1*xp(alpha+alphas,deltas)),(1.1*yp(alpha+alphas,deltas)) center tc rgb "blue"
plot xp(alpha+alphas,deltas),yp(alpha+alphas,deltas) w p ls 12



unset multiplot
